<?php

/*

Copyright (c) 2009 Anant Garg, http://anantgarg.com

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

*/

require "config.php";
require "db.php";

if (file_exists("db.version.php")) {
	require "db.version.php";
} else {
	define('DB_LAST_IMPORT',0);
}

$importFiles = array();
$newVersion = DB_LAST_IMPORT;
if ($handle = opendir(dirname(__FILE__).'/db')) {

    while (false !== ($file = readdir($handle))) {
       if (is_file(dirname(__FILE__).'/db/'.$file)) {
		   if (preg_match('/(\d+)\.sql/',$file,$match)) {
			   if ((int)$match[1] > DB_LAST_IMPORT) {
					array_push($importFiles,$match[1]);
					$newVersion = $match[1];
			   }
			
		   }
	   }
    }

    closedir($handle);
}


if (isset($_GET['action'])) {

if ($_GET['action'] == "bvc") {
	htmlheader();


connect();
ob_start();

$backupFile = date('YmdHis', time()).'.sql';

if (!file_exists('db/'.$backupFile)) {
	$command = 'mysqldump --opt -h'.DBPATH.' -u'.DBUSER.' -p'.DBPASS.' '.DB.' > db/backup/'.$backupFile;
	system($command);

	echo "<div class=\"box green\">Database backup successful - <a href=\"db/backup/$backupFile\" class=\"linka\" target=\"_blank\">db/backup/$backupFile</a></div>";

} else {
	echo "<div class=\"box red\">Unable to backup. Do you have write permissions? mysqldump?</div>";
	htmlfooter();
	exit;
}

ob_flush();
flush(); 



$lastImport = DB_LAST_IMPORT;

$query = <<<EOD
			START TRANSACTION;
EOD;
	$result = mysql_query($query);

$fileError = 0;
$rollback = 0;
$errors = '';

foreach ($importFiles as $file) {



	$sql = file_get_contents(dirname(__FILE__).'/db/'.$file.'.sql');

	

	$sqlQueries = preg_split('/;[\r\n]+/',$sql);

	foreach ($sqlQueries as $query) {
		if (strlen($query) > 4) {
		$result = mysql_query($query);
			if (!$result) {
				$errors .= "Error in version <b>$file</b>: ".mysql_error()."<br/>\n";
				$rollback = 1;
			}
		}
	}
	
	$lastImport = $file;

}

if (!empty($importFiles)) {

		if ($rollback == 0) {
			$query = <<<EOD
					COMMIT;
EOD;
			$result = mysql_query($query);
			
			echo '<div class="box green">Version upgrade successful. Committing.<br/>';

			$data = <<<EOD
<?php
define ('DB_LAST_IMPORT','$lastImport');
EOD;

			$fp = fopen('db.version.php', 'w');
			fwrite($fp, $data);
			fclose($fp);
			
			echo "Current Database Version: ".$lastImport."</div>";

		} else {
			
			$query = <<<EOD
					ROLLBACK;
EOD;
			$result = mysql_query($query);
			echo "<div class=\"box red\">Version upgrade could not be successfully implemented. Rolling back. </div>\n";
			echo "<div class=\"box\">$errors</div>";
		}

} else {

			echo '<div class="box blue">No upgrade required.<br/>Current Database Version: '.$lastImport.'</div>';
}

htmlfooter();

ob_end_flush();
} else {
	$nodata = "";
	if (isset($_GET['nodata']) && $_GET['nodata'] == "true") {
		$nodata = '--no-data=true';
	}
htmlheader();
$backupFile = '1.sql';

if (!file_exists('db/'.$backupFile)) {
	$command = 'mysqldump --opt -h'.DBPATH.' -u'.DBUSER.' -p'.DBPASS.' '.DB.' '.$nodata.' > db/'.$backupFile;
	system($command);

			echo '<div class="box green">Baseline has been successfully created.</div>';
} else {
			echo "<div class=\"box red\">Baseline already exists. Please create sequential files inorder to update your database.</div>\n";
}

htmlfooter();
}
} else {
htmlheader();


$lastImport = DB_LAST_IMPORT;
$extra = '';
if ($lastImport < $newVersion) {
	$extra = 'Database version upgrade available.';
} else if ($lastImport = $newVersion) {
	$extra = 'No database version upgrade required.';
} 

echo <<<EOD

<div class="box"><h2>How to use?</h2><br/><span style="color:#333333">1. If this is the first time you are adding your database to your repository, please select <b>baseline</b> option.<br/>
2. Everytime you make a change to the db schema, create a corresponding .sql file (2,3...). You may club multiple SQL queries in a single file. Every <b>svn update</b> can have a single .sql file associated with it (if any changes were made to the schema).
<br/>3. Do <b>NOT</b> add <b>db.version.php</b> file to your SVN repository.</span>
<br/>4. Then <b>svn update/switch</b> on your live server and point your browser to this file and select <b>backup &amp version upgrade</b> option.
<br/>5. Either all the changes will be imported or none will be imported.
<br/><br/>For step-by-step instructions, please visit <a href="http://anantgarg.com" target="_blank" style="color:black;text-decoration:none;border-bottom:1px dashed">http://anantgarg.com</a>

</div>

<div class="box"><h2>Server database version: $lastImport<br/>Repository database version: $newVersion<br/><br/>$extra</h2>
</div>

	<a href="?action=baseline" style="color:black" ><span class="box green" style="width:220px;float:left"><h2>Generate Baseline (with data)</h2></span></a>
		<a href="?action=baseline&nodata=true" style="color:black" ><span class="box green" style="width:240px;float:left"><h2>Generate Baseline (without data)</h2></span></a>
<a href="?action=bvc" style="color:black"><span class="box blue"  style="width:195px;float:left"><h2>Backup & Version Upgrade</h2></span></a>
	<br clear="all"/>
EOD;

htmlfooter();

}

function htmlheader() {
echo <<<EOD
<html>
<head>
<title>Database Backup and Version Control</title>
<style>
body {
	font-family: Georgia, serif;
	font-size: 13px;
	font-style: italic;
	font-weight: normal;
	text-transform: normal;
	letter-spacing: normal;
	line-height: 1.6em;
	background-color:#eeeeee;
}
.wrapper {
	margin:0 auto;
	width:960px;
}
.box {
	-moz-border-radius-bottomleft:11px;
	-moz-border-radius-bottomright:11px;
	-moz-border-radius-topleft:11px;
	-moz-border-radius-topright:11px;
	background:#FFFFFF none repeat scroll 0%;
	border:1px solid #E5E5E5;
	font-weight:normal;
	margin-left:8px;
	padding:16px 16px 16px;
	margin-top:15px;
}


.red {
	background-color:#c20d0d;
	color:white;
}
.green {
	background-color:#ecffcf;
}
.blue {
	background-color:#cff5ff;
}
h1 {
font-family:Georgia,"Times New Roman","Bitstream Charter",Times,serif;
font-size:24px;
font-size-adjust:none;
font-stretch:normal;
font-style:italic;
font-variant:normal;
font-weight:normal;
padding:0;
margin:0;
padding-left:30px;
padding-top:10px;
padding-bottom:10px;
}
h2 {
font-family:Georgia,"Times New Roman","Bitstream Charter",Times,serif;
font-size:16px;
font-size-adjust:none;
font-stretch:normal;
font-style:italic;
font-variant:normal;
font-weight:normal;
padding:0;
margin:0;
}
.linka {
	text-decoration:none;
	color:#000000;
	border-bottom:1px dashed #000000;
}
</style>
</head>
<body>
<div class="wrapper">
<h1>Database Backup &amp; Version Control</h1>
EOD;

}

function htmlfooter() {
echo <<<EOD
</div>
</body>
</html>

EOD;
}